package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;
import org.openqa.selenium.Keys;
import org.openqa.selenium.WebElement;
import org.openqa.selenium.interactions.Actions;

public class PlanejamentodeProducaoPage extends PageBase {
    //Mapping
    By menubutton = By.xpath("//*[@class='bars']");
    By campopesquisar = By.xpath("//section[@class='zh-container-search-menu']//input[@type='text']");
    By planejamentodeproducaobutton = By.xpath("//span[text()='Planejamento da Produção']");

    By descricaoField = By.id("DSPLANEJPRODUCAO");
    By datadaproducaoField = By.id("DTPRODUCAO");
    By lupaunidadesagregadas = By.xpath("//*[@id='NMFILIAGREGA']//span[@class='right-search zh-ripple-effect zh-icon zh-icon-search zh-icon-no-border']");
    By selecionarunidadeagregada = By.xpath("//span[text()='DEPOSITO BC 111']");
    By okButton = By.xpath("//span[text()='Ok']");
    By filtrarButton = By.xpath("//span[text()='Filtrar']");
    By selecionartodosplanejamentos = By.xpath("//*[@class='th grid-checkbox-column fixed']");

    By quantidadedplanejadaField = By.xpath("//span[text()='600,00000']");
    By editarprodacabadoButton = By.xpath("//*[@class='zh-test-box']");
    By quantidadeaproduzirField = By.id("QTAPRODUZIR");
    By justificativaalteracaoField = By.id("DSJUSTIFICA");
    By salvaralteracaoButton = By.xpath("//span[text()='Salvar']");
    By confirmarinsercaosaldorestanteButton = By.xpath("//span[text()='Sim']");
    By voltarButton = By.xpath("//span[text()='Voltar']");

    By abaquantidadedemateriaprima = By.xpath("//a[text()='Quantidade Total de Matéria Prima']");
    By salvaralteracoesButton = By.xpath("//span[text()='Salvar alterações']");
    By abaprodutoacabado = By.xpath("//a[text()='Produto Acabado']");
    By quantidadeliberadaField = By.xpath("//*[@class='editable-content']");

    By gerarnovopp = By.xpath("//span[text()='Gerar Novo (PP)']");
    By lupapp = By.xpath("//*[@id='NRPLANPROD']//span[@class='zh-icon zh-icon-search zh-icon-no-border']");
    By selecionarpp = By.xpath("//span[text()='186']");
    By acaobutton = By.xpath("//span[text()='Ações']");
    By susbstituirprato = By.xpath("//span[text()='Substituir Prato']");
    By campodprato = By.xpath("//*[@class='editable selected-autocomplete ng-pristine ng-valid ng-touched']");
    By campoprato = By.xpath("//*[@id='NMPRATO']//span[@class='zh-icon zh-icon-search zh-icon-no-border']");
    By selecionarprato = By.xpath("//span[text()='FEIJOADA SIMPLES']");
    By campodeunidade = By.xpath("//*[@id='NMFILIAL']//span[@class='left-search zh-ripple-effect zh-icon zh-icon-search zh-icon-no-border']");
    By selecionarunidade = By.xpath("//span[text()='DEPOSITO BC 111']");
    By okselecionarunidade = By.xpath("//span[text()='OK']");
    By camposervico = By.xpath("//*[@id='NMFILISERV'//span[@class='left-search zh-ripple-effect zh-icon zh-icon-search zh-icon-no-border']");
    By selecionarservico = By.xpath("//span[text()='ALMOÇO TRANSPORTADA']");
    By okselecionarservico = By.xpath("span[text()='OK']");
    By camposalvar = By.xpath("//span[text()='Salvar']");
    By substituicaopratofeitabutton = By.xpath("//section[@class='zh-container-alert']//p[@class='zh-text-alert']");
    By botaoOKsubstituicaodeprato = By.xpath("//span[@data-ng-bind=\"button.label\"]");
    By msgconfirmacaocancelamentorealizado = By.xpath("span[text()='Cancelamento realizado com sucesso!']");

    By botaoacoes = By.xpath("//span[text()='Ações']");
    By opcaocancelarPP = By.xpath("//span[text()='Cancelar Planejamento da Produção']");
    By botaosim = By.xpath("//span[text()='Sim']");
    By PPcancelado = By.xpath("//section[@class='zh-container-alert']//p[@class='zh-text-alert']");
    By botaookPPCancelado = By.xpath("//*[@class='zh-alert-button']");


    By plangerado = By.xpath("//span[text()='OK']");
    By botaoselecionarprodacabado = By.xpath("//*[@class='td grid-checkbox-column zh-side-column fixed zh-ripple-effect']");
    By liberarparaproduc = By.xpath("//*[@class='zh-icon zh-icon-file-next zh-icon-color-black']");
    By producaogerada = By.xpath("//section[@class=\"zh-container-alert\"]//p[@class=\"zh-text-alert\"]");
    By botaookplangerado = By.xpath("//*[@class='zh-alert-button']");

    By gerarpedidodeproducaobutton = By.xpath("//span[text()='Gerar Pedido de Produção']");
    By confirmargeracaodopedido = By.xpath("//span[text()='Sim']");

    By CancelarSubstituicaoButton = By.xpath("//span[text()='Cancelar Substituição']");

    By AtualizarCardápioButton = By.xpath("//span[text()='Atualizar Cardápio']");


    //Actions
    public void AcessarTela() {
        try {
            Thread.sleep(5000);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
        click(menubutton);
        sendKeys(campopesquisar, "Planejamento da Produção");
        click(planejamentodeproducaobutton);
    }

    // Gerar Planejamento de Produção
    public void preencherdescricao(String descricao) {
        //waitForVisibilityOfElementLocated(loadingWait);
        //waitForInvisibilityOfElementLocated(loadingWait);
        sendKeys(descricaoField, descricao);
    }
    public void informardatadeaprodc(String dataproducc) {
        try {
            Thread.sleep(3000);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
        //waitForVisibilityOfElementLocated(loadingWait);
        //waitForInvisibilityOfElementLocated(loadingWait);
        click(datadaproducaoField);
        sendKeys(datadaproducaoField, dataproducc);
        try {
            Thread.sleep(2000);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
        javaScriptExecutor.executeScript("document.querySelector(\"#popup > span > section > section > section > div\").scrollBy(0,350)");
    }
    public void selecionaragregada() {
        click(lupaunidadesagregadas);
        click(selecionarunidadeagregada);
        click(okButton);
        javaScriptExecutor.executeScript("document.querySelector(\"#popup > span > section > section > section > div\").scrollBy(0,350)");
    }
    public void clicaremfiltrar() {
        //waitForVisibilityOfElementLocated(loadingWait);
        //waitForInvisibilityOfElementLocated(loadingWait);
        try {
            Thread.sleep(3000);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
        click(filtrarButton);
    }

    public void clicarokplangerado (){
        click(plangerado);
    }
    public void clicarparaselecionarpa () {
        click(botaoselecionarprodacabado);
    }
    public void liberarparaproducao (){
        click(liberarparaproduc);
    }
    public String retornamsgdeproducaogerada (){
        return getText(producaogerada);
    }

    public void clicarbotaookposplan (){
        try {
            Thread.sleep(3000);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
        click(botaookplangerado);
    }

    // QUANTIDADE PLANEJADA
    public void alterarquantidadeplanejada(String quantproduzir, String justificativa) {
        click(quantidadedplanejadaField);
        click(editarprodacabadoButton);
        click(quantidadeaproduzirField);
        clear(quantidadeaproduzirField);
        sendKeys(quantidadeaproduzirField, quantproduzir) ;
        click(justificativaalteracaoField);
        sendKeys(justificativaalteracaoField, justificativa);
        click(salvaralteracaoButton);
        try {
            Thread.sleep(2000);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
        click(confirmarinsercaosaldorestanteButton);
        click(voltarButton);
    }

    // QUANTIDADE LIBERADA
    public void alterarquantidademateriaprima() {
        click(abaquantidadedemateriaprima);
    }
    public void editarquantidadeliberada() {
        try {
            Thread.sleep(5000);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
        Actions edit = new Actions(driver);
        WebElement element = driver.findElement(quantidadeliberadaField);
        edit.moveToElement(element).click();
        edit.sendKeys(element, Keys.BACK_SPACE);
        edit.sendKeys(element, "14.200,000").build().perform();
    }

    public void salvaralteracoesqtliberada(){
        click(salvaralteracoesButton);
        click(abaprodutoacabado);
    }


    // SUBSTITUIR PRATO
    public void substituirprato(){
        click(botaoselecionarprodacabado);
        click(acaobutton);
        click(susbstituirprato);
        click(campodprato);
        try {
            Thread.sleep(2000);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
        click(campoprato);
        click(selecionarprato);
        click(campodeunidade);
        click(selecionarunidade);
        click(okselecionarunidade);
        click(camposervico);
        click(selecionarservico);
        click(okselecionarservico);
        click(camposalvar);

    }
    //CLICAR OK APÓS SUBSTITUIÇÃO DO PRATO
    public void clicaroksubstituicaodoprato(){
        try {
            Thread.sleep(3000);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
        click(botaoOKsubstituicaodeprato);
    }

    public String substituicaopratoefetivada(){
        return getText(substituicaopratofeitabutton);
    }

    public void selecionarppgerado() {
        click(gerarnovopp);
        click(lupapp);
        click(selecionarpp);
        click(filtrarButton);
        click(selecionarpp);
        click(selecionartodosplanejamentos);
        click(acaobutton);
        click(opcaocancelarPP);
        click(botaosim);
    }

    public String retornoppcancelado(){
        return getText(PPcancelado);
    }

    public void okplanexcluido() {
        try {
            Thread.sleep(3000);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
        click(botaookPPCancelado);
    }

    // GERAR PEDIDO DE PRODUÇÃO
    public void clicargerarpedidodeproducao (){
        click(gerarnovopp);
        click(lupapp);
        click(selecionarpp);
        click(filtrarButton);
        click(selecionarpp);
        click(selecionartodosplanejamentos);
        click(acaobutton);
        click(gerarpedidodeproducaobutton);
        click(confirmargeracaodopedido);
    }

    // CANCELAR SUBSTITUIÇÃO
    public void clicarparacancelarsubstituicao(){
        click(gerarnovopp);
        click(lupapp);
        click(selecionarpp);
        click(filtrarButton);
        click(selecionarpp);
        click(selecionartodosplanejamentos);
        click(acaobutton);
        click(CancelarSubstituicaoButton);
    }

    public String cancelamentosubstituicao(){
        return getText(msgconfirmacaocancelamentorealizado);
    }


    }






